"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelCreate = void 0;
const Channel_1 = require("../../resources/Channel");
const Constants_1 = require("../../utils/Constants");
const Event_1 = require("./Event");
class ChannelCreate extends Event_1.Event {
    run(data) {
        const existing = this.client.channels.cache.has(data.id);
        let guild;
        if ("guild_id" in data) {
            guild = this.getGuild(data.guild_id);
        }
        if (!existing) {
            const channel = Channel_1.Channel.from({ ...data, client: this.client }, guild);
            if (guild) {
                guild.channels.add(channel);
            }
            this.client.emit(Constants_1.Events.ChannelCreate, this.client.channels.add(channel));
        }
    }
}
exports.ChannelCreate = ChannelCreate;
