"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelDelete = void 0;
const Event_1 = require("./Event");
const index_1 = require("../../utils/index");
const Constants_1 = require("../../utils/Constants");
class ChannelDelete extends Event_1.Event {
    run(data) {
        const channel = (0, index_1.structuredClone)(this.client.channels.cache.get(data.id));
        let guild;
        if ("guild_id" in data) {
            guild = this.getGuild(data.guild_id);
        }
        if (guild) {
            guild.channels.cache.delete(data.id);
        }
        this.client.channels.cache.delete(data.id);
        this.client.emit(Constants_1.Events.ChannelDelete, channel);
    }
}
exports.ChannelDelete = ChannelDelete;
