"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelPinsUpdate = void 0;
const Channel_1 = require("../../resources/Channel");
const Constants_1 = require("../../utils/Constants");
const Event_1 = require("./Event");
class ChannelPinsUpdate extends Event_1.Event {
    run(data) {
        let guild;
        if ("guild_id" in data) {
            guild = this.getGuild(data.guild_id);
        }
        const channel = this.client.channels.cache.get(data.channel_id);
        if (Channel_1.TextBasedChannel.isBased(channel)) {
            const oldLastPinTimestamp = channel.lastPinTimestamp;
            if (data.last_pin_timestamp) {
                channel.lastPinTimestamp = Date.parse(data.last_pin_timestamp);
            }
            if (guild) {
                guild.channels.add(channel);
            }
            this.client.channels.add(channel);
            const disabledEvents = this.client.options.gateway.disabledEvents;
            if (channel.lastPinTimestamp &&
                oldLastPinTimestamp < channel.lastPinTimestamp &&
                !disabledEvents.includes("channelPinsAdd")) {
                this.client.emit(Constants_1.Events.ChannelPinsAdd, oldLastPinTimestamp, channel.lastPinTimestamp, channel);
            }
            else if (channel.lastPinTimestamp &&
                oldLastPinTimestamp > channel.lastPinTimestamp &&
                !disabledEvents.includes("channelPinsRemove")) {
                this.client.emit(Constants_1.Events.ChannelPinsRemove, oldLastPinTimestamp, channel.lastPinTimestamp, channel);
            }
            else {
                this.client.emit(Constants_1.Events.ChannelPinsUpdate, channel);
            }
        }
    }
}
exports.ChannelPinsUpdate = ChannelPinsUpdate;
