"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelUpdate = void 0;
const Channel_1 = require("../../resources/Channel");
const Event_1 = require("./Event");
const index_1 = require("../../utils/index");
const Constants_1 = require("../../utils/Constants");
class ChannelUpdate extends Event_1.Event {
    run(data) {
        const old = (0, index_1.structuredClone)(this.client.channels.cache.get(data.id));
        let guild;
        if ("guild_id" in data) {
            guild = this.getGuild(data.guild_id);
        }
        const updated = Channel_1.Channel.from({ ...data, client: this.client }, guild);
        if (guild) {
            guild.channels.add(updated);
        }
        this.client.channels.add(updated);
        this.client.emit(Constants_1.Events.ChannelUpdate, old, updated);
    }
}
exports.ChannelUpdate = ChannelUpdate;
