"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuildEmojisUpdate = void 0;
const Constants_1 = require("../../utils/Constants");
const DataManager_1 = require("../../manager/DataManager");
const Event_1 = require("./Event");
class GuildEmojisUpdate extends Event_1.Event {
    run(data) {
        const guild = this.getGuild(data.guild_id);
        if (!guild)
            return;
        const deleted = new DataManager_1.DataCache(guild.emojis.cache);
        const oldEmojis = new DataManager_1.DataCache(guild.emojis.cache);
        for (const rawmoji of data.emojis) {
            const emoji = guild.emojis.cache.get(rawmoji.id);
            if (emoji) {
                deleted.delete(emoji.id);
                this.client.emit(Constants_1.Events.GuildEmojiUpdate, emoji, guild.emojis.add(rawmoji));
            }
            else {
                this.client.emit(Constants_1.Events.GuildEmojiCreate, guild.emojis.add(rawmoji));
            }
        }
        for (const emoji of deleted.values()) {
            this.client.emit(Constants_1.Events.GuildEmojiDelete, emoji);
            guild.emojis.cache.delete(emoji.id);
        }
        this.client.emit(Constants_1.Events.GuildEmojisUpdate, oldEmojis, guild.emojis.cache, guild);
    }
}
exports.GuildEmojisUpdate = GuildEmojisUpdate;
