"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuildMemberUpdate = void 0;
const Member_1 = require("../../resources/Member");
const Event_1 = require("./Event");
const index_1 = require("../../utils/index");
const Constants_1 = require("../../utils/Constants");
class GuildMemberUpdate extends Event_1.Event {
    run(data) {
        const guild = this.getGuild(data.guild_id);
        if (!guild)
            return;
        const oldMember = (0, index_1.structuredClone)(guild.members.cache.get(data.user.id));
        const updatedData = oldMember
            ? Object.assign(oldMember.rawData, data)
            : { ...data, deaf: null, mute: null };
        const updated = guild.members.add(new Member_1.Member({
            ...updatedData,
        }, guild));
        this.client.emit(Constants_1.Events.GuildMemberUpdate, oldMember, updated);
    }
}
exports.GuildMemberUpdate = GuildMemberUpdate;
