"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuildScheduledEventCreate = void 0;
const Event_1 = require("./Event");
const Guild_1 = require("../../resources/Guild");
const Constants_1 = require("../../utils/Constants");
class GuildScheduledEventCreate extends Event_1.Event {
    run(data) {
        const guild = this.getGuild(data.guild_id);
        if (!guild)
            return;
        const event = new Guild_1.ScheduledEvent(data, guild);
        guild.scheduledEvents.set(event.id, event);
        this.client.emit(Constants_1.Events.GuildScheduledEventCreate, event);
    }
}
exports.GuildScheduledEventCreate = GuildScheduledEventCreate;
