"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageDelete = void 0;
const Event_1 = require("./Event");
const index_1 = require("../../utils/index");
const Constants_1 = require("../../utils/Constants");
const Channel_1 = require("../../resources/Channel");
class MessageDelete extends Event_1.Event {
    run(data) {
        const channel = this.client.channels.cache.get(data.channel_id);
        if (Channel_1.TextBasedChannel.isBased(channel)) {
            if (!channel?.messages.cache.has(data.id))
                return;
            if (channel.isThread())
                channel.messageCount--;
            const message = (0, index_1.structuredClone)(channel.messages.get(data.id));
            this.client.emit(Constants_1.Events.MessageDelete, message);
            channel.messages.cache.delete(data.id);
        }
    }
}
exports.MessageDelete = MessageDelete;
