"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThreadCreate = void 0;
const Event_1 = require("./Event");
const Channel_1 = require("../../resources/Channel");
const Constants_1 = require("../../utils/Constants");
class ThreadCreate extends Event_1.Event {
    run(data) {
        const guild = this.getGuild(data.guild_id);
        const channel = this.client.channels.cache.get(data.parent_id);
        const thread = new Channel_1.ThreadChannel({
            ...data,
            client: this.client,
        }, guild);
        if (channel?.isGuildChannel())
            channel.threads._add(thread);
        this.client.cache.threads._add(thread);
        this.client.emit(Constants_1.Events.ThreadCreate, thread);
    }
}
exports.ThreadCreate = ThreadCreate;
