"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThreadDelete = void 0;
const Constants_1 = require("../../utils/Constants");
const v10_1 = require("discord-api-types/v10");
const Channel_1 = require("../../resources/Channel");
const Event_1 = require("./Event");
class ThreadDelete extends Event_1.Event {
    run(data) {
        let thread = this.client.cache.threads.get(data.id);
        if (data.type === v10_1.ChannelType.PublicThread ||
            data.type === v10_1.ChannelType.PrivateThread) {
            const guild = this.getGuild(data.guild_id);
            if (guild) {
                thread = new Channel_1.ThreadChannel({
                    client: this.client,
                    ...data,
                }, guild);
            }
        }
        if (thread) {
            this.client.emit(Constants_1.Events.ThreadDelete, thread);
            this.client.cache.threads.delete(data.id);
        }
    }
}
exports.ThreadDelete = ThreadDelete;
