"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThreadMemberUpdate = void 0;
const Member_1 = require("../../resources/Member");
const Constants_1 = require("../../utils/Constants");
const Event_1 = require("./Event");
class ThreadMemberUpdate extends Event_1.Event {
    run(data) {
        const thread = this.client.cache.threads.get(data.id);
        if (thread) {
            const channel = thread.channel;
            const member = new Member_1.ThreadMember({
                ...data,
                client: this.client,
            }, thread);
            thread.member = member;
            this.client.cache.threads._add(thread);
            channel?.threads._add(thread);
            this.client.emit(Constants_1.Events.ThreadMemberUpdate, member);
        }
    }
}
exports.ThreadMemberUpdate = ThreadMemberUpdate;
