"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypingStart = void 0;
const Constants_1 = require("../../utils/Constants");
const Event_1 = require("./Event");
class TypingStart extends Event_1.Event {
    run(data) {
        let guild, member;
        if (data.guild_id) {
            guild = this.getGuild(data.guild_id);
            member = guild?.members.cache.get(data.user_id);
        }
        const startedTimestamp = data.timestamp;
        const channelId = data.channel_id;
        const guildId = data.guild_id;
        const userId = data.user_id;
        const channel = this.client.channels.cache.get(channelId);
        this.client.emit(Constants_1.Events.TypingStart, {
            channelId,
            channel,
            startedTimestamp,
            guild,
            member,
            guildId,
            userId,
        });
    }
}
exports.TypingStart = TypingStart;
