"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuildDataManager = void 0;
const Guild_1 = require("../resources/Guild");
const Member_1 = require("../resources/Member");
const utils_1 = require("@darkcord/utils");
const v10_1 = require("discord-api-types/v10");
const DataManager_1 = require("./DataManager");
const Forgified_1 = require("../resources/forge/Forgified");
class GuildDataManager extends DataManager_1.DataManager {
    manager;
    constructor(manager, limit) {
        super(limit);
        this.manager = manager;
    }
    get(id) {
        return this.cache.get(id);
    }
    forge(data) {
        const forged = new Forgified_1.Forge(this.manager.client, Guild_1.Guild).forge(typeof data === "string" ? { id: data } : data);
        return this.add(forged, false);
    }
    async fetch(id, options = {}) {
        const raw = await this.manager.client.rest.getGuild(id);
        const guild = new Guild_1.Guild({ ...raw, client: this.manager.client });
        if (options.fetchMembers && "websocket" in this.manager.client) {
            if (!(this.manager.client.options.gateway.intents &
                v10_1.GatewayIntentBits.GuildMembers)) {
                throw (0, utils_1.MissingIntentsError)("GuildMembers");
            }
            const members = await this.manager.client.rest.getGuildMembers(guild.id);
            for (const raw of members) {
                guild.members.add(new Member_1.Member(raw, guild), true);
            }
        }
        return guild;
    }
}
exports.GuildDataManager = GuildDataManager;
