"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MemberDataManager = void 0;
const Member_1 = require("../resources/Member");
const DataManager_1 = require("./DataManager");
const Forgified_1 = require("../resources/forge/Forgified");
class MemberDataManager extends DataManager_1.DataManager {
    manager;
    guild;
    constructor(options, manager, guild) {
        super(options, (get, id) => {
            const g = get(id);
            if (!g)
                return;
            return g instanceof Member_1.Member ? g : new Member_1.Member(g, this.guild);
        });
        this.manager = manager;
        this.guild = guild;
    }
    get(id) {
        return this.cache.get(id);
    }
    add(member, replace = true) {
        return super.add(member, replace, member.id);
    }
    forge(data, guild) {
        const forged = new Forgified_1.Forge(this.manager.client, Member_1.Member).forge(typeof data === "string" ? { id: data } : data, guild);
        return this.add(forged, false);
    }
    async fetch(id) {
        const member = await this.manager.client.rest.getGuildMember(this.guild.id, id);
        return this.add(new Member_1.Member(member, this.guild));
    }
}
exports.MemberDataManager = MemberDataManager;
