"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionOverwrite = exports.Permissions = void 0;
const v10_1 = require("discord-api-types/v10");
const Base_1 = require("./Base");
const BitField_1 = require("./BitField");
class Permissions extends BitField_1.BitField {
    allow;
    deny;
    constructor(allow, deny = 0n) {
        super(BigInt(allow), v10_1.PermissionFlagsBits);
        this.allow = allow;
        this.deny = deny;
        this.allow = BigInt(allow);
        this.deny = BigInt(deny);
    }
    static Flags = v10_1.PermissionFlagsBits;
    static Default = BigInt(104324673);
    static All = Object.values(v10_1.PermissionFlagsBits).reduce((all, p) => all | p, 0n);
}
exports.Permissions = Permissions;
class PermissionOverwrite extends Base_1.Base {
    channel;
    permissions;
    type;
    constructor(data, channel) {
        super(data, data.client);
        this.channel = channel;
        this.permissions = Object.freeze(new Permissions(BigInt(data.allow), BigInt(data.deny)));
        this.type = data.type;
    }
}
exports.PermissionOverwrite = PermissionOverwrite;
