"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sticker = void 0;
const Base_1 = require("./Base");
class Sticker extends Base_1.Base {
    /**
     * For standard stickers, id of the pack the sticker is from
     */
    packId;
    /**
     * Name of the sticker
     */
    name;
    /**
     * Description of the sticker
     */
    description;
    /**
     * Autocomplete/suggestion tags for the sticker (max 200 characters)
     */
    tags;
    /**
     * Type of sticker
     */
    type;
    /**
     * Type of sticker format
     */
    formatType;
    /**
     * Whether this guild sticker can be used, may be false due to loss of Server Boosts
     */
    available;
    /**
     * Id of the guild that owns this sticker
     */
    guildId;
    /**
     * The user that uploaded the guild sticker
     */
    user;
    /**
     * The standard sticker's sort order within its pack
     */
    sortValue;
    constructor(data) {
        super(data);
        this.name = data.name;
        this.packId = data.pack_id;
        this.description = data.description;
        this.tags = data.tags;
        this.type = data.type;
        this.formatType = data.format_type;
        this.available = data.available;
        this.guildId = data.guild_id;
        this.user = data.user ? this._client.users.add(data.user) : null;
        this.sortValue = data.sort_value;
    }
    toJSON() {
        return Base_1.Base.toJSON(this, [
            "available",
            "createdAt",
            "description",
            "formatType",
            "guildId",
            "id",
            "name",
            "packId",
            "rawData",
            "sortValue",
            "tags",
            "type",
            "user",
        ]);
    }
}
exports.Sticker = Sticker;
