"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuildAuditLogEntryCreate = void 0;
const Constants_1 = require("../../../utils/Constants");
const index_1 = require("../../../utils/index");
const Event_1 = require("./Event");
class GuildAuditLogEntryCreate extends Event_1.Event {
  run(data) {
    const log = {
      actionType: data.action_type,
      changes: data.changes?.map((c) =>
        (0, index_1.objectSnakeKeysToCamelKeys)(c),
      ),
      id: data.id,
      options:
        data.options && (0, index_1.objectSnakeKeysToCamelKeys)(data.options),
      reason: data.reason,
      userId: data.user_id,
      targetId: data.target_id,
    };
    this.client.emit(Constants_1.Events.GuildAuditLogEntryCreate, log);
  }
}
exports.GuildAuditLogEntryCreate = GuildAuditLogEntryCreate;
