"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuildMembersChunk = void 0;
const Member_1 = require("../../../resources/Member");
const Constants_1 = require("../../../utils/Constants");
const Event_1 = require("./Event");
class GuildMembersChunk extends Event_1.Event {
  run(data) {
    let guild = this.getGuild(data.guild_id);
    if (!guild) return;
    let members = data.members;
    if (members) {
      members = members.map((member) => new Member_1.Member(member, guild));
      for (const member of members) {
        guild.members.add(member);
      }
    }
    if (data.presences) {
      for (const presence of data.presences) {
        guild.presences.push(presence);
      }
    }
    this.client.emit(Constants_1.Events.GuildMembersChunk, {
      chunkCount: data.chunk_count,
      chunkIndex: data.chunk_index,
      notFound: data.not_found,
      nonce: data.nonce,
      guildId: data.guild_id,
      guild,
      members,
    });
    if (data.chunk_index >= data.chunk_count - 1) {
      this.client.emit(
        Constants_1.Events.GuildMembersChunked,
        guild,
        data.chunk_count,
      );
    }
  }
}
exports.GuildMembersChunk = GuildMembersChunk;
