"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuildRoleUpdate = void 0;
const Event_1 = require("./Event");
const index_1 = require("../../../utils/index");
const Constants_1 = require("../../../utils/Constants");
class GuildRoleUpdate extends Event_1.Event {
  run(data) {
    const guild = this.getGuild(data.guild_id);
    if (!guild) return;
    const old = (0, index_1.structuredClone)(
      guild.roles.cache.get(data.role.id),
    );
    const updated = guild.roles.add(data.role);
    this.client.emit(Constants_1.Events.GuildRoleUpdate, old, updated, guild);
  }
}
exports.GuildRoleUpdate = GuildRoleUpdate;
