"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuildScheduledEventDelete = void 0;
const Event_1 = require("./Event");
const index_1 = require("../../../utils/index");
const Constants_1 = require("../../../utils/Constants");
class GuildScheduledEventDelete extends Event_1.Event {
  run(data) {
    const guild = this.getGuild(data.guild_id);
    if (!guild) return;
    const deleted = (0, index_1.structuredClone)(
      guild.scheduledEvents.get(data.id),
    );
    guild.scheduledEvents.delete(data.id);
    this.client.emit(Constants_1.Events.GuildScheduledEventDelete, deleted);
  }
}
exports.GuildScheduledEventDelete = GuildScheduledEventDelete;
