"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuildScheduledEventUpdate = void 0;
const Event_1 = require("./Event");
const Guild_1 = require("../../../resources/Guild");
const index_1 = require("../../../utils/index");
const Constants_1 = require("../../../utils/Constants");
class GuildScheduledEventUpdate extends Event_1.Event {
  run(data) {
    const guild = this.getGuild(data.guild_id);
    if (!guild) return;
    const event = new Guild_1.ScheduledEvent(data, guild);
    const old = (0, index_1.structuredClone)(
      guild.scheduledEvents.get(event.id),
    );
    guild.scheduledEvents.set(event.id, event);
    this.client.emit(Constants_1.Events.GuildScheduledEventUpdate, old, event);
  }
}
exports.GuildScheduledEventUpdate = GuildScheduledEventUpdate;
