"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuildStickersUpdate = void 0;
const Event_1 = require("./Event");
const Constants_1 = require("../../../utils/Constants");
const DataManager_1 = require("../../manager/DataManager");
class GuildStickersUpdate extends Event_1.Event {
  run(data) {
    const guild = this.getGuild(data.guild_id);
    if (!guild) return;
    const deleted = new DataManager_1.DataCache(guild.stickers.cache);
    const oldStickers = new DataManager_1.DataCache(guild.stickers.cache);
    for (const rawsticker of data.stickers) {
      const sticker = guild.stickers.cache.get(rawsticker.id);
      if (sticker) {
        deleted.delete(sticker.id);
        this.client.emit(
          Constants_1.Events.GuildStickerUpdate,
          sticker,
          guild.stickers.add(rawsticker),
        );
      } else {
        this.client.emit(
          Constants_1.Events.GuildStickerCreate,
          guild.stickers.add(rawsticker),
        );
      }
    }
    for (const sticker of deleted.values()) {
      this.client.emit(Constants_1.Events.GuildStickerDelete, sticker);
      guild.stickers.cache.delete(sticker.id);
    }
    this.client.emit(
      Constants_1.Events.GuildStickersUpdate,
      oldStickers,
      guild.stickers.cache,
      guild,
    );
  }
}
exports.GuildStickersUpdate = GuildStickersUpdate;
