"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuildUpdate = void 0;
const Guild_1 = require("../../../resources/Guild");
const Event_1 = require("./Event");
const index_1 = require("../../../utils/index");
const Constants_1 = require("../../../utils/Constants");
class GuildUpdate extends Event_1.Event {
  run(data) {
    const old = (0, index_1.structuredClone)(this.getGuild(data.id));
    if (old) {
      const updated = this.client.guilds.add(
        new Guild_1.Guild({ ...data, client: this.client }),
      );
      this.client.emit(Constants_1.Events.GuildUpdate, old, updated);
    }
  }
}
exports.GuildUpdate = GuildUpdate;
