"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InviteCreate = void 0;
const Invite_1 = require("../../../resources/Invite");
const Event_1 = require("./Event");
const Constants_1 = require("../../../utils/Constants");
class InviteCreate extends Event_1.Event {
  run(data) {
    const guild = this.getGuild(data.guild_id);
    const channel = this.client.channels.cache.get(data.channel_id);
    const invite = new Invite_1.Invite({
      guild: guild?.rawData,
      channel: channel.rawData,
      client: this.client,
      ...data,
    });
    if (guild) {
      guild.invites.set(invite.code, invite);
    }
    this.client.emit(Constants_1.Events.InviteCreate, invite);
  }
}
exports.InviteCreate = InviteCreate;
