"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InviteDelete = void 0;
const Constants_1 = require("../../../utils/Constants");
const Invite_1 = require("../../../resources/Invite");
const Event_1 = require("./Event");
class InviteDelete extends Event_1.Event {
  run(data) {
    const guild = this.getGuild(data.guild_id);
    if (!guild) return;
    const deleted =
      guild.invites.get(data.code) ||
      new Invite_1.Invite({
        client: this.client,
        channel: guild.channels.cache.get(data.channel_id),
        code: data.code,
        guild: guild.rawData,
      });
    this.client.emit(Constants_1.Events.InviteDelete, deleted);
  }
}
exports.InviteDelete = InviteDelete;
