"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageCreate = void 0;
const Message_1 = require("../../../resources/Message");
const Event_1 = require("./Event");
const Resolvable_1 = require("../../../utils/Resolvable");
const Constants_1 = require("../../../utils/Constants");
class MessageCreate extends Event_1.Event {
  async run(data) {
    let guild;
    if (data.guild_id) {
      guild = this.getGuild(data.guild_id);
    }
    const message = new Message_1.Message(
      {
        ...data,
        client: this.client,
      },
      guild,
    );
    this.client.emit(
      Constants_1.Events.MessageCreate,
      Resolvable_1.Resolvable.resolveMessage(message, this.client),
    );
  }
}
exports.MessageCreate = MessageCreate;
