"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageDeleteBulk = void 0;
const Channel_1 = require("../../../resources/Channel");
const Constants_1 = require("../../../utils/Constants");
const index_1 = require("../../../utils/index");
const Event_1 = require("./Event");
class MessageDeleteBulk extends Event_1.Event {
  run(data) {
    const channel = this.client.channels.cache.get(data.channel_id);
    if (Channel_1.TextBasedChannel.isBased(channel)) {
      const messages = new Map();
      for (const id of data.ids) {
        if (!channel.messages.cache.has(id)) continue;
        if (channel instanceof Channel_1.ThreadChannel) channel.messageCount--;
        const message = (0, index_1.structuredClone)(channel.messages.get(id));
        channel.messages.cache.delete(id);
        messages.set(message.id, message);
      }
      this.client.emit(Constants_1.Events.MessageDeleteBulk, messages);
    }
  }
}
exports.MessageDeleteBulk = MessageDeleteBulk;
