"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageReactionAdd = void 0;
const Channel_1 = require("../../../resources/Channel");
const Emoji_1 = require("../../../resources/Emoji");
const Constants_1 = require("../../../utils/Constants");
const Event_1 = require("./Event");
class MessageReactionAdd extends Event_1.Event {
  async run(data) {
    const raw = {
      count: 0,
      emoji: data.emoji,
      me: data.user_id === this.client.user.id,
    };
    const reaction = this.client.cache._partial(Constants_1.Partials.Reaction)
      ? raw
      : new Emoji_1.Reaction({ ...raw, client: this.client });
    const channel = this.client.channels.cache.get(data.channel_id);
    const user = await this.getUser(data.user_id);
    if (Channel_1.TextBasedChannel.isBased(channel)) {
      if (reaction instanceof Emoji_1.Reaction) reaction.users.add(user);
      const message =
        channel.messages.get(data.message_id) ||
        (await channel.messages.fetch(data.message_id));
      message.reactions._add(
        reaction,
        true,
        reaction.emoji.id ?? reaction.emoji.name,
      );
      this.client.emit(
        Constants_1.Events.MessageReactionAdd,
        reaction,
        user,
        message,
      );
    }
  }
}
exports.MessageReactionAdd = MessageReactionAdd;
