"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageReactionRemoveEmoji = void 0;
const Channel_1 = require("../../../resources/Channel");
const Constants_1 = require("../../../utils/Constants");
const index_1 = require("../../../utils/index");
const Event_1 = require("./Event");
class MessageReactionRemoveEmoji extends Event_1.Event {
  run(data) {
    const emoji = data.emoji;
    const channel = this.client.channels.cache.get(data.channel_id);
    if (Channel_1.TextBasedChannel.isBased(channel)) {
      const message = channel.messages.get(data.message_id);
      if (message) {
        const removed = (0, index_1.structuredClone)(
          message.reactions.get(emoji.id),
        );
        message.reactions.delete(emoji.id);
        this.client.emit(
          Constants_1.Events.MessageReactionRemoveEmoji,
          message,
          removed,
        );
      }
    }
  }
}
exports.MessageReactionRemoveEmoji = MessageReactionRemoveEmoji;
