"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageUpdate = void 0;
const Message_1 = require("../../../resources/Message");
const Event_1 = require("./Event");
const index_1 = require("../../../utils/index");
const Resolvable_1 = require("../../../utils/Resolvable");
const Constants_1 = require("../../../utils/Constants");
class MessageUpdate extends Event_1.Event {
  async run(data) {
    const channel = this.client.channels.cache.get(data.channel_id);
    const old = (0, index_1.structuredClone)(channel.messages.get(data.id));
    let guild;
    if (data.guild_id) {
      guild = this.getGuild(data.guild_id);
    }
    const updated = new Message_1.Message(
      {
        ...data,
        client: this.client,
      },
      guild,
    );
    this.client.emit(
      Constants_1.Events.MessageUpdate,
      old,
      Resolvable_1.Resolvable.resolveMessage(updated, this.client),
    );
  }
}
exports.MessageUpdate = MessageUpdate;
