"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThreadMembersUpdate = void 0;
const Member_1 = require("../../../resources/Member");
const Event_1 = require("./Event");
const Constants_1 = require("../../../utils/Constants");
class ThreadMembersUpdate extends Event_1.Event {
  run(data) {
    const thread = this.client.cache.threads.get(data.id);
    if (thread) {
      const addedMembers = data.added_members?.map(
        (member) =>
          new Member_1.ThreadMember({ ...member, client: this.client }, thread),
      );
      if (addedMembers) {
        for (const member of addedMembers) {
          thread.members._add(member);
        }
      }
      if (data.removed_member_ids) {
        for (const id of data.removed_member_ids) {
          thread.members.delete(id);
        }
      }
      const channel = this.client.channels.cache.get(thread.channel.id);
      if (channel) channel.threads._add(thread);
      this.client.threads._add(thread);
      this.client.emit(
        Constants_1.Events.ThreadMembersUpdate,
        addedMembers,
        data.removed_member_ids,
      );
    }
  }
}
exports.ThreadMembersUpdate = ThreadMembersUpdate;
