"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Team = exports.TeamMember = void 0;
class TeamMember {
  /**
   * The user's membership state on the team
   */
  membershipState;
  /**
   * Will always be ["*"]
   */
  permissions;
  /**
   * The id of the parent team of which they are a member
   */
  teamId;
  /**
   * The user of team
   */
  user;
  constructor(data) {
    this.permissions = ["*"];
    this.teamId = data.team_id;
    this.user = data.client.users.add(data.user, false);
    this.membershipState = data.membership_state;
  }
}
exports.TeamMember = TeamMember;
class Team {
  /**
   * A hash of the image of the team's icon
   */
  icon;
  id;
  /**
   * The members of the team
   */
  members;
  /**
   * The name of the team
   */
  name;
  /**
   * The user id of the current team owner
   */
  ownerUserId;
  constructor(data) {
    this.icon = data.icon;
    this.id = data.id;
    this.members = data.members.map(
      (member) => new TeamMember({ ...member, client: data.client }),
    );
    this.name = data.name;
    this.ownerUserId = data.owner_user_id;
  }
}
exports.Team = Team;
