"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PresenceUpdateStatus =
  exports.ApplicationRoleConnectionMetadataType =
  exports.AutoModerationRuleKeywordPresetType =
  exports.ApplicationCommandPermissionType =
  exports.TextInputStyle =
  exports.GuildScheduledEventEntityType =
  exports.AutoModerationRuleTriggerType =
  exports.MembershipScreeningFieldType =
  exports.ApplicationCommandOptionType =
  exports.AutoModerationRuleEventType =
  exports.AutoModerationActionType =
  exports.InteractionResponseType =
  exports.MessageActivityType =
  exports.AuditLogOptionsType =
  exports.StickerFormatType =
  exports.AllowedMentionsTypes =
  exports.ApplicationCommandType =
  exports.UserPremiumType =
  exports.ForumLayoutType =
  exports.SortOrderType =
  exports.OverwriteType =
  exports.ComponentType =
  exports.GuildHubType =
  exports.ActivityType =
  exports.WebhookType =
  exports.StickerType =
  exports.MessageType =
  exports.ChannelType =
  exports.InviteTargetType =
  exports.InteractionType =
  exports.ImageFormat =
  exports.UserFlags =
  exports.ThreadMemberFlags =
  exports.PermissionFlagsBits =
  exports.MessageFlags =
  exports.GuildSystemChannelFlags =
  exports.GatewayIntentBits =
  exports.ChannelFlags =
  exports.ApplicationFlags =
  exports.ActivityFlags =
  exports.channelMention =
  exports.roleMention =
  exports.userMention =
  exports.timestampFormat =
  exports.InvitePattern =
  exports.Events =
  exports.ShardEvents =
  exports.GatewayStatus =
  exports.Partials =
    void 0;
var Partials;
(function (Partials) {
  Partials[(Partials["Emoji"] = 0)] = "Emoji";
  Partials[(Partials["User"] = 1)] = "User";
  Partials[(Partials["Reaction"] = 2)] = "Reaction";
  Partials[(Partials["Role"] = 3)] = "Role";
  Partials[(Partials["Sticker"] = 4)] = "Sticker";
})((Partials = exports.Partials || (exports.Partials = {})));
var ws_1 = require("@darkcord/ws");
Object.defineProperty(exports, "GatewayStatus", {
  enumerable: true,
  get: function () {
    return ws_1.GatewayStatus;
  },
});
Object.defineProperty(exports, "ShardEvents", {
  enumerable: true,
  get: function () {
    return ws_1.ShardEvents;
  },
});
var Events;
(function (Events) {
  // Gateway
  Events["Packet"] = "packet";
  Events["Ready"] = "ready";
  Events["Reconnecting"] = "reconnecting";
  Events["Connect"] = "connect";
  Events["ShardConnect"] = "shardConnect";
  Events["ShardDebug"] = "shardDebug";
  Events["ShardClose"] = "shardClose";
  Events["ShardResume"] = "shardResume";
  Events["ShardReady"] = "shardReady";
  Events["ShardReconnectRequired"] = "shardReconnectRequired";
  Events["ShardPing"] = "shardPing";
  Events["ShardHello"] = "shardHello";
  Events["ShardPreReady"] = "shardPreReady";
  Events["ShardError"] = "shardError";
  Events["ShardDispatch"] = "shardDispatch";
  // Message
  Events["MessageCreate"] = "messageCreate";
  Events["MessageDelete"] = "messageDelete";
  Events["MessageUpdate"] = "messageUpdate";
  Events["MessageDeleteBulk"] = "messageDeleteBulk";
  Events["MessageReactionAdd"] = "messageReactionAdd";
  Events["MessageReactionRemove"] = "messageReactionRemove";
  Events["MessageReactionRemoveAll"] = "messageReactionRemoveAll";
  Events["MessageReactionRemoveEmoji"] = "messageReactionRemoveEmoji";
  Events["TypingStart"] = "typingStart";
  // Interaction
  Events["InteractionCreate"] = "interactionCreate";
  // Guild
  Events["GuildMembersChunk"] = "guildMembersChunk";
  Events["GuildMembersChunked"] = "guildMembersChunked";
  Events["GuildCreate"] = "guildCreate";
  Events["GuildUpdate"] = "guildUpdate";
  Events["GuildDelete"] = "guildDelete";
  Events["GuildAuditLogEntryCreate"] = "guildAuditLogEntryCreate";
  Events["GuildBanAdd"] = "guildBanAdd";
  Events["GuildBanRemove"] = "guildBanRemove";
  Events["GuildEmojisUpdate"] = "guildEmojisUpdate";
  Events["GuildEmojiCreate"] = "guildEmojiCreate";
  Events["GuildEmojiDelete"] = "guildEmojiDelete";
  Events["GuildEmojiUpdate"] = "guildEmojiUpdate";
  Events["GuildStickersUpdate"] = "guildStickersUpdate";
  Events["GuildStickerUpdate"] = "guildStickerUpdate";
  Events["GuildStickerCreate"] = "guildStickerCreate";
  Events["GuildStickerDelete"] = "guildStickerDelete";
  Events["GuildMemberAdd"] = "guildMemberAdd";
  Events["GuildMemberRemove"] = "guildMemberRemove";
  Events["GuildMemberUpdate"] = "guildMemberUpdate";
  Events["GuildIntegrationsUpdate"] = "guildIntegrationsUpdate";
  Events["GuildRoleCreate"] = "guildRoleCreate";
  Events["GuildRoleDelete"] = "guildRoleDelete";
  Events["GuildRoleUpdate"] = "guildRoleUpdate";
  Events["GuildScheduledEventCreate"] = "guildScheduledEventCreate";
  Events["GuildScheduledEventDelete"] = "guildScheduledEventDelete";
  Events["GuildScheduledEventUpdate"] = "guildScheduledEventUpdate";
  Events["GuildScheduledEventUserAdd"] = "guildScheduledEventUserAdd";
  Events["GuildScheduledEventUserRemove"] = "guildScheduledEventUserRemove";
  // Thread
  Events["ThreadCreate"] = "threadCreate";
  Events["ThreadDelete"] = "threadDelete";
  Events["ThreadListSync"] = "threadListSync";
  Events["ThreadMemberUpdate"] = "threadMemberUpdate";
  Events["ThreadMembersUpdate"] = "threadMembersUpdate";
  // Stage
  Events["StageInstanceCreate"] = "stageInstanceCreate";
  Events["StageInstanceDelete"] = "stageInstanceDelete";
  Events["StageInstanceUpdate"] = "stageInstanceUpdate";
  // Channels
  Events["ChannelCreate"] = "channelCreate";
  Events["ChannelDelete"] = "channelDelete";
  Events["ChannelUpdate"] = "channelUpdate";
  Events["ChannelPinsUpdate"] = "channelPinsUpdate";
  Events["ChannelPinsAdd"] = "channelPinsAdd";
  Events["ChannelPinsRemove"] = "channelPinsRemove";
  // User
  Events["UserUpdate"] = "userUpdate";
  // Voice
  Events["VoiceChannelSwitch"] = "voiceChannelSwitch";
  Events["VoiceChannelLeave"] = "voiceChannelLeave";
  Events["VoiceChannelJoin"] = "voiceChannelJoin";
  Events["VoiceServerUpdate"] = "voiceServerUpdate";
  Events["VoiceStateUpdate"] = "voiceStateUpdate";
  // Client
  Events["Warn"] = "warn";
  Events["Debug"] = "debug";
  // Integration
  Events["IntegrationCreate"] = "integrationCreate";
  // Invite
  Events["InviteCreate"] = "inviteCreate";
  Events["InviteDelete"] = "inviteDelete";
})((Events = exports.Events || (exports.Events = {})));
exports.InvitePattern =
  /discord(?:(?:app)?\.com\/invite|\.gg(?:\/invite)?)\/(?<code>[\w-]{2,255})/i;
function timestampFormat(time, style) {
  return `<t:${time}${style ? `:${style}` : ""}>`;
}
exports.timestampFormat = timestampFormat;
function userMention(userId) {
  return `<@${userId}>`;
}
exports.userMention = userMention;
function roleMention(roleId) {
  return `<@&${roleId}>`;
}
exports.roleMention = roleMention;
function channelMention(channelId) {
  return `<#${channelId}>`;
}
exports.channelMention = channelMention;
var v10_1 = require("discord-api-types/v10");
Object.defineProperty(exports, "ActivityFlags", {
  enumerable: true,
  get: function () {
    return v10_1.ActivityFlags;
  },
});
Object.defineProperty(exports, "ApplicationFlags", {
  enumerable: true,
  get: function () {
    return v10_1.ApplicationFlags;
  },
});
Object.defineProperty(exports, "ChannelFlags", {
  enumerable: true,
  get: function () {
    return v10_1.ChannelFlags;
  },
});
Object.defineProperty(exports, "GatewayIntentBits", {
  enumerable: true,
  get: function () {
    return v10_1.GatewayIntentBits;
  },
});
Object.defineProperty(exports, "GuildSystemChannelFlags", {
  enumerable: true,
  get: function () {
    return v10_1.GuildSystemChannelFlags;
  },
});
Object.defineProperty(exports, "MessageFlags", {
  enumerable: true,
  get: function () {
    return v10_1.MessageFlags;
  },
});
Object.defineProperty(exports, "PermissionFlagsBits", {
  enumerable: true,
  get: function () {
    return v10_1.PermissionFlagsBits;
  },
});
Object.defineProperty(exports, "ThreadMemberFlags", {
  enumerable: true,
  get: function () {
    return v10_1.ThreadMemberFlags;
  },
});
Object.defineProperty(exports, "UserFlags", {
  enumerable: true,
  get: function () {
    return v10_1.UserFlags;
  },
});
Object.defineProperty(exports, "ImageFormat", {
  enumerable: true,
  get: function () {
    return v10_1.ImageFormat;
  },
});
Object.defineProperty(exports, "InteractionType", {
  enumerable: true,
  get: function () {
    return v10_1.InteractionType;
  },
});
Object.defineProperty(exports, "InviteTargetType", {
  enumerable: true,
  get: function () {
    return v10_1.InviteTargetType;
  },
});
Object.defineProperty(exports, "ChannelType", {
  enumerable: true,
  get: function () {
    return v10_1.ChannelType;
  },
});
Object.defineProperty(exports, "MessageType", {
  enumerable: true,
  get: function () {
    return v10_1.MessageType;
  },
});
Object.defineProperty(exports, "StickerType", {
  enumerable: true,
  get: function () {
    return v10_1.StickerType;
  },
});
Object.defineProperty(exports, "WebhookType", {
  enumerable: true,
  get: function () {
    return v10_1.WebhookType;
  },
});
Object.defineProperty(exports, "ActivityType", {
  enumerable: true,
  get: function () {
    return v10_1.ActivityType;
  },
});
Object.defineProperty(exports, "GuildHubType", {
  enumerable: true,
  get: function () {
    return v10_1.GuildHubType;
  },
});
Object.defineProperty(exports, "ComponentType", {
  enumerable: true,
  get: function () {
    return v10_1.ComponentType;
  },
});
Object.defineProperty(exports, "OverwriteType", {
  enumerable: true,
  get: function () {
    return v10_1.OverwriteType;
  },
});
Object.defineProperty(exports, "SortOrderType", {
  enumerable: true,
  get: function () {
    return v10_1.SortOrderType;
  },
});
Object.defineProperty(exports, "ForumLayoutType", {
  enumerable: true,
  get: function () {
    return v10_1.ForumLayoutType;
  },
});
Object.defineProperty(exports, "UserPremiumType", {
  enumerable: true,
  get: function () {
    return v10_1.UserPremiumType;
  },
});
Object.defineProperty(exports, "ApplicationCommandType", {
  enumerable: true,
  get: function () {
    return v10_1.ApplicationCommandType;
  },
});
Object.defineProperty(exports, "AllowedMentionsTypes", {
  enumerable: true,
  get: function () {
    return v10_1.AllowedMentionsTypes;
  },
});
Object.defineProperty(exports, "StickerFormatType", {
  enumerable: true,
  get: function () {
    return v10_1.StickerFormatType;
  },
});
Object.defineProperty(exports, "AuditLogOptionsType", {
  enumerable: true,
  get: function () {
    return v10_1.AuditLogOptionsType;
  },
});
Object.defineProperty(exports, "MessageActivityType", {
  enumerable: true,
  get: function () {
    return v10_1.MessageActivityType;
  },
});
Object.defineProperty(exports, "InteractionResponseType", {
  enumerable: true,
  get: function () {
    return v10_1.InteractionResponseType;
  },
});
Object.defineProperty(exports, "AutoModerationActionType", {
  enumerable: true,
  get: function () {
    return v10_1.AutoModerationActionType;
  },
});
Object.defineProperty(exports, "AutoModerationRuleEventType", {
  enumerable: true,
  get: function () {
    return v10_1.AutoModerationRuleEventType;
  },
});
Object.defineProperty(exports, "ApplicationCommandOptionType", {
  enumerable: true,
  get: function () {
    return v10_1.ApplicationCommandOptionType;
  },
});
Object.defineProperty(exports, "MembershipScreeningFieldType", {
  enumerable: true,
  get: function () {
    return v10_1.MembershipScreeningFieldType;
  },
});
Object.defineProperty(exports, "AutoModerationRuleTriggerType", {
  enumerable: true,
  get: function () {
    return v10_1.AutoModerationRuleTriggerType;
  },
});
Object.defineProperty(exports, "GuildScheduledEventEntityType", {
  enumerable: true,
  get: function () {
    return v10_1.GuildScheduledEventEntityType;
  },
});
Object.defineProperty(exports, "TextInputStyle", {
  enumerable: true,
  get: function () {
    return v10_1.TextInputStyle;
  },
});
Object.defineProperty(exports, "ApplicationCommandPermissionType", {
  enumerable: true,
  get: function () {
    return v10_1.ApplicationCommandPermissionType;
  },
});
Object.defineProperty(exports, "AutoModerationRuleKeywordPresetType", {
  enumerable: true,
  get: function () {
    return v10_1.AutoModerationRuleKeywordPresetType;
  },
});
Object.defineProperty(exports, "ApplicationRoleConnectionMetadataType", {
  enumerable: true,
  get: function () {
    return v10_1.ApplicationRoleConnectionMetadataType;
  },
});
Object.defineProperty(exports, "PresenceUpdateStatus", {
  enumerable: true,
  get: function () {
    return v10_1.PresenceUpdateStatus;
  },
});
