import { Client, InteractionClient } from "../client/Client";
import { ClientChannelsDataManager } from "../manager/ChannelDataManager";
import { DataCache } from "../manager/DataManager";
import { EmojiDataManager } from "../manager/EmojiDataManager";
import { GuildDataManager } from "../manager/GuildDataManager";
import { ClientRoles } from "../manager/RoleDataManager";
import { UserDataManager } from "../manager/UserDataManager";
import { ThreadChannel } from "../resources/Channel";
import { Cache } from "./Cache";
export declare class CacheManager {
    client: Client | InteractionClient;
    channels: ClientChannelsDataManager;
    guilds: GuildDataManager;
    emojis: EmojiDataManager;
    users: UserDataManager;
    roles: ClientRoles;
    threads: DataCache<ThreadChannel>;
    constructor(client: Client | InteractionClient);
    _createCache(option: "channels" | "roles" | "users" | "guilds" | "emojis" | "threads"): ClientRoles | UserDataManager | EmojiDataManager | GuildDataManager | ClientChannelsDataManager | DataCache<Record<string, any>>;
    cleanup(clearGuilds?: boolean): void;
    _cacheInstance(o: any): o is Cache<any>;
    _cacheLimit(option: string): number;
}
//# sourceMappingURL=CacheManager.d.ts.map