import { GatewayPresenceUpdateData, GatewaySendPayload } from "discord-api-types/v10";
import { GatewayShard } from "@darkcord/ws";
import { Client } from "./Client";
import { Cache } from "../cache/Cache";
export declare class WebSocket {
    #private;
    client: Client;
    shards: Cache<GatewayShard>;
    totalShards: number;
    maxConcurrency: number;
    constructor(client: Client);
    get ping(): number;
    handleShards(): Promise<void>;
    handleShard(gatewayShard: GatewayShard): Promise<void>;
    connect(): Promise<void>;
    disconnect(): void;
    broadcast(payload: GatewaySendPayload): void;
    setStatus(data: Partial<GatewayPresenceUpdateData>): void;
    setShardStatus(shardId: string, data: Partial<GatewayPresenceUpdateData>): void;
    allReady(): boolean;
    /**
     * Emits "ready" event to client if all shards has ready
     */
    fireClientReady(): void;
}
//# sourceMappingURL=WebSocket.d.ts.map