import { CacheManager } from "../cache/CacheManager";
import { Channel } from "../resources/Channel";
import { Guild } from "../resources/Guild";
import { BaseCacheOptions } from "../types/index";
import { APIChannel } from "discord-api-types/v10";
import { DataManager } from "./DataManager";
import { GuildResolvable } from "../utils/Resolvable";
import { Forged } from "../resources/forge/Forgified";
export declare class ChannelDataManager extends DataManager<Channel> {
    manager: CacheManager;
    constructor(options: number | BaseCacheOptions, manager: CacheManager);
    _resolve(channel: APIChannel | Channel, guild?: Guild, addInCache?: boolean): Channel;
    add(channel: Channel | APIChannel, replace?: boolean): Channel;
    get(id: string): Channel | undefined;
    forge(id: string): Channel;
    forge(data: Forged<APIChannel>): Channel;
    fetch(id: string): Promise<Channel>;
}
export declare class ClientChannelsDataManager extends ChannelDataManager {
    _add(channel: APIChannel | Channel, guild?: GuildResolvable, replace?: boolean): Channel;
}
export declare class GuildChannelDataManager extends ChannelDataManager {
    guild: Guild;
    constructor(options: number | BaseCacheOptions, manager: CacheManager, guild: Guild);
    add(channel: APIChannel | Channel, replace?: boolean): Channel;
}
//# sourceMappingURL=ChannelDataManager.d.ts.map