import { Cache, CacheEntries } from "../cache/Cache";
import { BaseCacheOptions } from "../types/index";
type DataResolver<V> = (this: Cache<V>, getFn: (key: string) => V | undefined, key: string) => V | undefined;
export declare class DataCache<V extends Record<string, any>> extends Cache<V> {
    #private;
    _setResolver(resolver: DataResolver<V>): void;
    get(key: string): V | undefined;
    _add(item: V, replace?: boolean, id?: string): V;
}
export declare class DataManager<V extends Record<string, any>> {
    cache: DataCache<V>;
    constructor(entries?: CacheEntries<string, V>, resolver?: DataResolver<V>);
    constructor(entries?: Readonly<Readonly<[string, V]>[]>, resolver?: DataResolver<V>);
    constructor(entries?: Iterable<Readonly<[string, V]>>, resolver?: DataResolver<V>);
    constructor(limit?: number, entries?: Readonly<Readonly<[string, V]>[]>, resolver?: DataResolver<V>);
    constructor(limit?: number, entries?: Readonly<Readonly<[string, V]>[]>, resolver?: DataResolver<V>);
    constructor(limit?: number, entries?: Iterable<Readonly<[string, V]>>, resolver?: DataResolver<V>);
    constructor(limit?: BaseCacheOptions<V> | number | CacheEntries<string, V>, entries?: CacheEntries<string, V> | DataResolver<V>, resolver?: DataResolver<V>);
    constructor(limit?: BaseCacheOptions<V> | number, entries?: CacheEntries<string, V> | DataResolver<V>, resolver?: DataResolver<V>);
    constructor(limit?: BaseCacheOptions<V> | number, entries?: Readonly<Readonly<[string, V]>[]> | DataResolver<V>, resolver?: DataResolver<V>);
    constructor(limit?: BaseCacheOptions<V> | number, entries?: Iterable<Readonly<[string, V]>> | DataResolver<V>, resolver?: DataResolver<V>);
    add(item: V, replace?: boolean, id?: string): V;
}
export {};
//# sourceMappingURL=DataManager.d.ts.map