import { CacheManager } from "../cache/CacheManager";
import { Emoji } from "../resources/Emoji";
import { Guild } from "../resources/Guild";
import { BaseCacheOptions } from "../types/index";
import { APIEmoji, APIGuild } from "discord-api-types/v10";
import { DataManager } from "./DataManager";
import { Forged } from "../resources/forge/Forgified";
export declare class EmojiDataManager extends DataManager<Emoji> {
    #private;
    manager: CacheManager;
    constructor(options: number | BaseCacheOptions, manager: CacheManager);
    get(id: string): Emoji | undefined;
    add(emoji: Emoji | APIEmoji, replace?: boolean): Emoji;
    forge(idOrName: string): Emoji;
    forge(data: Forged<APIEmoji, never>): Emoji;
    /**
     *
     * @param id emoji id
     * @param guild Guild object or Guild Id
     */
    fetch(id: string, guild: APIGuild | Guild | string): Promise<Emoji>;
}
export declare class GuildEmojiDataManager extends EmojiDataManager {
    manager: CacheManager;
    guild: Guild;
    constructor(options: number | BaseCacheOptions, manager: CacheManager, guild: Guild);
    fetch(id: string): Promise<Emoji>;
}
//# sourceMappingURL=EmojiDataManager.d.ts.map