import { CacheManager } from "../cache/CacheManager";
import { TextBasedChannel } from "../resources/Channel";
import { Message, APIMessage } from "../resources/Message";
import { BaseCacheOptions } from "../types/index";
import { RESTGetAPIChannelMessagesQuery } from "discord-api-types/v10";
import { DataManager } from "./DataManager";
import { Forged } from "../resources/forge/Forgified";
export declare class MessageDataManager extends DataManager<Message> {
    manager: CacheManager;
    channel: TextBasedChannel;
    constructor(options: number | BaseCacheOptions, manager: CacheManager, channel: TextBasedChannel);
    get(id: string): Message | undefined;
    forge(id: string): Message;
    forge(data: Forged<APIMessage>): Message;
    fetch(id: string): Promise<Message>;
    fetch(options: RESTGetAPIChannelMessagesQuery): Promise<Message[]>;
}
//# sourceMappingURL=MessageDataManager.d.ts.map