import { CacheManager } from "../cache/CacheManager";
import { Guild } from "../resources/Guild";
import { Role } from "../resources/Role";
import { BaseCacheOptions } from "../types/index";
import { APIGuild, APIRole } from "discord-api-types/v10";
import { DataCache, DataManager } from "./DataManager";
export declare class ClientRoles {
    cache: DataCache<Role>;
    constructor(options?: number | BaseCacheOptions<Role>);
}
export declare class RoleDataManager extends DataManager<Role> {
    manager: CacheManager;
    guild: Guild;
    constructor(options: number | BaseCacheOptions<Role>, manager: CacheManager, guild: Guild);
    /**
     * Returns the everyone role of the guild
     * @returns
     */
    get everyone(): Role | undefined;
    /**
     * Compare the position of role with another guild role
     * @param roleId The role id
     * @param otherRoleId The other role id
     * @returns
     */
    comparePositions(roleId: string, otherRoleId: string): number;
    premiumSubscriberRole(): Role | null;
    get(id: string): Role | undefined;
    add(role: APIRole | Role, replace?: boolean): Role;
    forge(id: string): Role;
    forge(data: APIRole): Role;
    _resolve(role: APIRole | Role, addInCache?: boolean): Role;
    /**
     *
     * @param id role id
     * @param guild Guild object or Guild Id
     */
    fetch(id: string, guild: APIGuild | Guild | string): Promise<Role | undefined>;
}
//# sourceMappingURL=RoleDataManager.d.ts.map