import { CacheManager } from "../cache/CacheManager";
import { Guild } from "../resources/Guild";
import { Sticker } from "../resources/Sticker";
import { BaseCacheOptions } from "../types/index";
import { APIGuild, APISticker } from "discord-api-types/v10";
import { DataManager } from "./DataManager";
export declare class StickerDataManager extends DataManager<Sticker> {
    #private;
    manager: CacheManager;
    constructor(options: number | BaseCacheOptions<Sticker>, manager: CacheManager);
    get(id: string): Sticker | undefined;
    add(sticker: Sticker | APISticker, replace?: boolean): Sticker;
    /**
     *
     * @param id sticker id
     * @param guild Guild object or Guild Id
     */
    _fetch(id: string, guild: APIGuild | Guild | string, addInCache?: boolean): Promise<Sticker>;
}
export declare class GuildStickerDataManager extends StickerDataManager {
    manager: CacheManager;
    guild: Guild;
    constructor(options: number | BaseCacheOptions<Sticker>, manager: CacheManager, guild: Guild);
    fetch(id: string, addInCache?: boolean): Promise<Sticker>;
}
//# sourceMappingURL=StickerDataManager.d.ts.map