import { Cache } from "../cache/Cache";
import { AnyClient } from "../types/index";
export declare namespace Snowflake {
    const InvalidSnowflakeError: (id: string) => Error | TypeError | RangeError | SyntaxError;
    function valid(id: string): boolean;
    function getEpoch(id: string): number;
    function getCreatedAt(id: string): number;
    function getCreatedTimestamp(id: string): number;
    function getWorkerId(id: string): number;
    function getProcessId(id: string): number;
    function getIncrement(id: string): number;
    /**
     * Checks if the snowflake is valid and if not, it throw's an error
     */
    function verify(id: string): boolean;
    function deconstruct(id: string): {
        timestamp: number;
        createdAt: number;
        workerId: number;
        processId: number;
        increment: number;
    };
    const Epoch = 1420070400000;
}
export declare class Base {
    _client: AnyClient;
    /**
     * Object id
     */
    id: string;
    rawData: Record<string, any> & {
        id?: string;
    };
    constructor(data: Record<string, any> & {
        id?: string;
    }, client?: AnyClient, id?: string);
    get createdAt(): number;
    toJSON(): void;
    static toJSON<T extends Base, U extends keyof T = keyof T>(source: T, props: U[]): ({ [K_2 in U as U extends never ? never : K_2]: T[K_2]; } extends infer T_2 ? { [K_1 in keyof T_2]: [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [Function] ? never : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [bigint] ? string : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [number] ? number : [K_1] extends [`_${string}`] ? never : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [any[]] ? { [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1] : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [Map<any, infer I1>] ? I1[] : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [Cache<infer I2>] ? I2[] : { [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]; } : never) extends infer T_1 ? { [K in keyof T_1 as ({ [K_2 in U as U extends never ? never : K_2]: T[K_2]; } extends infer T_2 ? { [K_1 in keyof T_2]: [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [Function] ? never : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [bigint] ? string : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [number] ? number : [K_1] extends [`_${string}`] ? never : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [any[]] ? { [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1] : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [Map<any, infer I1>] ? I1[] : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [Cache<infer I2>] ? I2[] : { [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]; } : never)[K] extends never ? never : K]: ({ [K_2 in U as U extends never ? never : K_2]: T[K_2]; } extends infer T_2 ? { [K_1 in keyof T_2]: [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [Function] ? never : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [bigint] ? string : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [number] ? number : [K_1] extends [`_${string}`] ? never : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [any[]] ? { [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1] : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [Map<any, infer I1>] ? I1[] : [{ [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]] extends [Cache<infer I2>] ? I2[] : { [K_2 in U as U extends never ? never : K_2]: T[K_2]; }[K_1]; } : never)[K]; } : never;
}
//# sourceMappingURL=Base.d.ts.map