import { AnyClient, DataWithClient } from "../types/index";
import { APIInvite, APIPartialChannel, APIUser, InviteTargetType } from "discord-api-types/v10";
import { GuildChannel } from "./Channel";
import { Guild, InviteGuild, ScheduledEvent } from "./Guild";
import { User } from "./User";
export declare class Invite {
    /**
     * The guild this invite is for
     */
    guild: Guild | InviteGuild | null;
    /**
     * The expiration date of this invite
     */
    expiresAt: number | null;
    /**
     * The user who created the invite
     */
    inviter: User | APIUser | null;
    /**
     * The invite code (unique ID)
     */
    code: string;
    /**
     * The channel this invite is for
     */
    channel?: GuildChannel | APIPartialChannel | null;
    /**
     * The type of target for this voice channel invite
     */
    targetType: InviteTargetType;
    /**
     * The user whose stream to display for this voice channel stream invite
     */
    targetUser: User | APIUser | null;
    /**
     * Approximate count of total members
     */
    approximateMemberCount: number;
    /**
     * Approximate count of online members
     */
    approximatePresenceCount: number;
    /**
     * The guild scheduled event
     */
    guildScheduledEvent: ScheduledEvent | null;
    _client: AnyClient;
    rawData: APIInvite;
    constructor(data: DataWithClient<Partial<APIInvite>>);
    _update(data: Partial<APIInvite>): this;
}
//# sourceMappingURL=Invite.d.ts.map