import { DataWithClient } from "../types/index";
import { APISticker, APIUser, StickerFormatType, StickerType } from "discord-api-types/v10";
import { Base } from "./Base";
import { User } from "./User";
export declare class Sticker extends Base {
    /**
     * For standard stickers, id of the pack the sticker is from
     */
    packId?: string | undefined;
    /**
     * Name of the sticker
     */
    name: string;
    /**
     * Description of the sticker
     */
    description: string | null;
    /**
     * Autocomplete/suggestion tags for the sticker (max 200 characters)
     */
    tags: string;
    /**
     * Type of sticker
     */
    type: StickerType;
    /**
     * Type of sticker format
     */
    formatType: StickerFormatType;
    /**
     * Whether this guild sticker can be used, may be false due to loss of Server Boosts
     */
    available?: boolean | undefined;
    /**
     * Id of the guild that owns this sticker
     */
    guildId?: string | undefined;
    /**
     * The user that uploaded the guild sticker
     */
    user?: User | APIUser | null;
    /**
     * The standard sticker's sort order within its pack
     */
    sortValue?: number | undefined;
    constructor(data: DataWithClient<APISticker>);
    toJSON(): {
        readonly createdAt: number;
        id: string;
        rawData: Record<string, any> & {
            id?: string | undefined;
        };
        description: string | null;
        name: string;
        type: number;
        user?: User | APIUser | null | undefined;
        available?: boolean | undefined;
        tags: string;
        guildId?: string | undefined;
        formatType: number;
        packId?: string | undefined;
        sortValue?: number | undefined;
    };
}
//# sourceMappingURL=Sticker.d.ts.map