import { Member } from "../Member";
import { Guild } from "../Guild";
import { User } from "../User";
import { Emoji, Reaction } from "../Emoji";
import { Message } from "../Message";
import { Application } from "../Application";
import { Channel, ForumChannel, GuildChannel, TextBasedChannel, GuildTextChannel, StageChannel, VoiceChannel, BaseVoiceChannel, CategoryChannel, ThreadChannel, WelcomeChannel, DMChannel } from "../Channel";
import { Role } from "../Role";
import { AnyClient } from "../../types/index";
export type ForgedConstructor = typeof Message | typeof Guild | typeof User | typeof Member | typeof Channel | typeof Emoji | typeof Reaction | typeof Application | typeof ForumChannel | typeof GuildChannel | typeof TextBasedChannel | typeof GuildTextChannel | typeof StageChannel | typeof VoiceChannel | typeof BaseVoiceChannel | typeof CategoryChannel | typeof ThreadChannel | typeof WelcomeChannel | typeof DMChannel | typeof CategoryChannel | typeof ForumChannel | typeof StageChannel | typeof Role;
type Implement<K extends string> = {
    [x in K]: string;
};
export type Forged<T, RequiredProp extends string = "id"> = Partial<Omit<T, RequiredProp>> & Implement<RequiredProp>;
export type ForgifiedConstructorParams<T extends ForgedConstructor, RequiredProp extends string = "id"> = {
    [K in keyof ConstructorParameters<T>]: ConstructorParameters<T>[K] extends Guild ? ConstructorParameters<T>[K] : Partial<Omit<ConstructorParameters<T>[K], RequiredProp>> & Implement<RequiredProp>;
};
export type ForgifiedParams<T extends ForgedConstructor> = ForgifiedConstructorParams<T>;
export declare class ForgifiedAPIError extends Error {
    constructor(message: string);
}
export declare namespace ForgifiedAPI {
    const Error: typeof ForgifiedAPIError;
    function CAN_BE_FORGED(x: ForgedConstructor): boolean;
    const FORGIFIED: unique symbol;
}
export declare class Forge<T extends ForgedConstructor> {
    client: AnyClient;
    base: T;
    constructor(client: AnyClient, base: T);
    forge(...params: Omit<ForgifiedParams<T>, keyof Array>): InstanceType<T>;
}
export {};
//# sourceMappingURL=Forgified.d.ts.map