import type { MessageTimestampStyle } from "../types/index";
export { GatewayStatus, ShardEvents } from "@darkcord/ws";
export declare enum Events {
    Packet = "packet",
    Ready = "ready",
    Reconnecting = "reconnecting",
    Connect = "connect",
    ShardConnect = "shardConnect",
    ShardDebug = "shardDebug",
    ShardClose = "shardClose",
    ShardResume = "shardResume",
    ShardReady = "shardReady",
    ShardReconnectRequired = "shardReconnectRequired",
    ShardPing = "shardPing",
    ShardHello = "shardHello",
    ShardPreReady = "shardPreReady",
    ShardError = "shardError",
    ShardDispatch = "shardDispatch",
    MessageCreate = "messageCreate",
    MessageDelete = "messageDelete",
    MessageUpdate = "messageUpdate",
    MessageDeleteBulk = "messageDeleteBulk",
    MessageReactionAdd = "messageReactionAdd",
    MessageSuperReactionAdd = "messageSuperReactionAdd",
    MessageReactionRemove = "messageReactionRemove",
    MessageSuperReactionRemove = "messageSuperReactionRemove",
    MessageReactionRemoveAll = "messageReactionRemoveAll",
    MessageReactionRemoveEmoji = "messageReactionRemoveEmoji",
    TypingStart = "typingStart",
    InteractionCreate = "interactionCreate",
    GuildMembersChunk = "guildMembersChunk",
    GuildMembersChunked = "guildMembersChunked",
    GuildCreate = "guildCreate",
    GuildUpdate = "guildUpdate",
    GuildDelete = "guildDelete",
    GuildAuditLogEntryCreate = "guildAuditLogEntryCreate",
    GuildBanAdd = "guildBanAdd",
    GuildBanRemove = "guildBanRemove",
    GuildEmojisUpdate = "guildEmojisUpdate",
    GuildEmojiCreate = "guildEmojiCreate",
    GuildEmojiDelete = "guildEmojiDelete",
    GuildEmojiUpdate = "guildEmojiUpdate",
    GuildStickersUpdate = "guildStickersUpdate",
    GuildStickerUpdate = "guildStickerUpdate",
    GuildStickerCreate = "guildStickerCreate",
    GuildStickerDelete = "guildStickerDelete",
    GuildMemberAdd = "guildMemberAdd",
    GuildMemberRemove = "guildMemberRemove",
    GuildMemberUpdate = "guildMemberUpdate",
    GuildIntegrationsUpdate = "guildIntegrationsUpdate",
    GuildRoleCreate = "guildRoleCreate",
    GuildRoleDelete = "guildRoleDelete",
    GuildRoleUpdate = "guildRoleUpdate",
    GuildScheduledEventCreate = "guildScheduledEventCreate",
    GuildScheduledEventDelete = "guildScheduledEventDelete",
    GuildScheduledEventUpdate = "guildScheduledEventUpdate",
    GuildScheduledEventUserAdd = "guildScheduledEventUserAdd",
    GuildScheduledEventUserRemove = "guildScheduledEventUserRemove",
    ThreadCreate = "threadCreate",
    ThreadDelete = "threadDelete",
    ThreadListSync = "threadListSync",
    ThreadMemberUpdate = "threadMemberUpdate",
    ThreadMembersUpdate = "threadMembersUpdate",
    StageInstanceCreate = "stageInstanceCreate",
    StageInstanceDelete = "stageInstanceDelete",
    StageInstanceUpdate = "stageInstanceUpdate",
    ChannelCreate = "channelCreate",
    ChannelDelete = "channelDelete",
    ChannelUpdate = "channelUpdate",
    ChannelPinsUpdate = "channelPinsUpdate",
    ChannelPinsAdd = "channelPinsAdd",
    ChannelPinsRemove = "channelPinsRemove",
    UserUpdate = "userUpdate",
    VoiceChannelSwitch = "voiceChannelSwitch",
    VoiceChannelLeave = "voiceChannelLeave",
    VoiceChannelJoin = "voiceChannelJoin",
    VoiceServerUpdate = "voiceServerUpdate",
    VoiceStateUpdate = "voiceStateUpdate",
    Warn = "warn",
    Debug = "debug",
    IntegrationCreate = "integrationCreate",
    InviteCreate = "inviteCreate",
    InviteDelete = "inviteDelete"
}
export declare const InvitePattern: RegExp;
export declare function timestampFormat<S extends MessageTimestampStyle>(time: number | string, style?: S): `<t:${string}:${S}>` | `<t:${string}>`;
export declare function userMention(userId: string): `<@${string}>`;
export declare function roleMention(roleId: string): `<@&${string}>`;
export declare function channelMention(channelId: string): `<#${string}>`;
export { ActivityFlags, ApplicationFlags, ChannelFlags, GatewayIntentBits, GuildSystemChannelFlags, MessageFlags, PermissionFlagsBits, ThreadMemberFlags, UserFlags, ImageFormat, InteractionType, InviteTargetType, ChannelType, MessageType, StickerType, WebhookType, ActivityType, GuildHubType, ComponentType, OverwriteType, SortOrderType, ForumLayoutType, UserPremiumType, ApplicationCommandType, AllowedMentionsTypes, StickerFormatType, AuditLogOptionsType, MessageActivityType, InteractionResponseType, AutoModerationActionType, AutoModerationRuleEventType, ApplicationCommandOptionType, MembershipScreeningFieldType, AutoModerationRuleTriggerType, GuildScheduledEventEntityType, TextInputStyle, ApplicationCommandPermissionType, AutoModerationRuleKeywordPresetType, ApplicationRoleConnectionMetadataType, PresenceUpdateReceiveStatus, PresenceUpdateStatus, type APIAuditLogChangeKeyEventType, type TextChannelType, type GuildChannelType, type GuildTextChannelType, type AuditLogRuleTriggerType, type APIGuildIntegrationType, type APIAuditLogChangeKeyType, type APIActionRowComponentTypes, type APIAuditLogChangeKeyEntityType, type APIAuditLogChangeKeyFormatType, type RESTPostAPIChannelTypingResult, type APIAuditLogChangeKeyTriggerType, type RESTPutAPIGuildTemplateSyncResult, } from "discord-api-types/v10";
//# sourceMappingURL=Constants.d.ts.map