import { InteractionClient } from "../client/Client";
import { CategoryChannel, Channel, DMChannel, GuildChannel, GuildTextChannel, StageChannel, TextBasedChannel, VoiceChannel } from "../resources/Channel";
import { Guild } from "../resources/Guild";
import { Interaction } from "../resources/Interaction";
import { Message, APIMessage } from "../resources/Message";
import { AnyClient } from "../types/index";
import { APIChannel, APIGuild } from "discord-api-types/v10";
export type GuildResolvable = Guild | APIGuild | string;
export type AnyChannel = Channel | TextBasedChannel | GuildChannel | GuildTextChannel | CategoryChannel | DMChannel | VoiceChannel | StageChannel;
export type ChannelResolvable = string | APIChannel | AnyChannel;
export type MessageResolvable = Message | (APIMessage & {
    guild_id?: string;
});
export declare namespace Resolvable {
    function resolveMessage(messageResolvable: MessageResolvable, client: AnyClient): Message;
    function resolveGuild(guildResolvable: GuildResolvable, client: AnyClient): Guild;
    function resolveChannel(channelResolvable: ChannelResolvable, client: AnyClient, guildResolvable?: GuildResolvable): DMChannel | Channel | TextBasedChannel | GuildChannel | GuildTextChannel | CategoryChannel | StageChannel | VoiceChannel;
    function resolvePartialHTTPInteractionValues(interaction: Interaction<false> | Interaction<true>, client: InteractionClient): Promise<Interaction<false>>;
}
//# sourceMappingURL=Resolvable.d.ts.map